<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------------
| URI ROUTING
| -------------------------------------------------------------------------
| This file lets you re-map URI requests to specific controller functions.
|
| Typically there is a one-to-one relationship between a URL string
| and its corresponding controller class/method. The segments in a
| URL normally follow this pattern:
|
|	example.com/class/method/id/
|
| In some instances, however, you may want to remap this relationship
| so that a different class/function is called than the one
| corresponding to the URL.
|
| Please see the user guide for complete details:
|
|	http://codeigniter.com/user_guide/general/routing.html
|
| -------------------------------------------------------------------------
| RESERVED ROUTES
| -------------------------------------------------------------------------
|
| There area two reserved routes:
|
|	$route['default_controller'] = 'welcome';
|
| This route indicates which controller class should be loaded if the
| URI contains no data. In the above example, the "welcome" class
| would be loaded.
|
|	$route['404_override'] = 'errors/page_missing';
|
| This route will tell the Router what URI segments to use if those provided
| in the URL cannot be matched to a valid route.
|
*/

// default
$route['default_controller'] = 'account/login';

// specific pages
$route['[L|l]ogin(.*)'] = 'account/login$1';
$route['LOGIN(.*)'] = 'account/login$1';

$route['[L|l]ogout(.*)'] = 'account/logout$1';
$route['LOGOUT(.*)'] = 'account/logout$1';

$route['[A|a]ccount(.*)'] = 'account/advanced_accounts';
$route['ACCOUNT(.*)'] = 'account/advanced_accounts';



$route['[H|h]ome(.*)'] = 'home_tab/home$1';
$route['HOME(.*)'] = 'home_tab/home$1';

$route['[P|p]orts/Diag(.*)'] = 'diagnostics_tab/ports$1';
$route['PORTS/DIAG(.*)'] = 'diagnostics_tab/ports$1';

$route['[E|e]ther[N|n]et/IP/Diag(.*)'] = 'diagnostics_tab/ethernet$1';
$route['ETHERNETIP/DIAG(.*)'] = 'diagnostics_tab/ethernet$1';

$route['[M|m]od[B|b]us/[T|t][C|c][P|p]/Diag(.*)'] = 'diagnostics_tab/modbus$1';
$route['MODBUS/[T|t][C|c][P|p]/DIAG(.*)'] = 'diagnostics_tab/modbus$1';

$route['[P|p]orts/[S|s]ettings(.*)'] = 'configuration_tab/port_settings$1';
$route['PORTS/SETTINGS(.*)'] = 'configuration_tab/port_settings$1';

$route['[P|p]ort_[S|s]ettings(.*)'] = 'configuration_tab/port_settings$1';
$route['PORT_SETTINGS(.*)'] = 'configuration_tab/port_settings$1';

$route['[E|e]thernet/IP/[S|s]ettings(.*)'] = 'configuration_tab/ethernetip_settings$1';
$route['ETHERNET/IP/SETTINGS(.*)'] = 'configuration_tab/ethernetip_settings$1';

$route['[M|m]odbus/TCP/[S|s]ettings(.*)'] = 'configuration_tab/modbustcp_settings$1';
$route['MODBUSTCP/SETTINGS(.*)'] = 'configuration_tab/modbustcp_settings$1';

$route['[D|d]igitalIO/[S|s]ettings(.*)'] = 'configuration_tab/digitalio_settings$1';
$route['DIGITALIO/SETTINGS(.*)'] = 'configuration_tab/digitalio$1';

$route['[N|n]etwork(.*)'] = 'configuration_tab/network$1';
$route['NETWORK(.*)'] = 'configuration_tab/network$1';

$route['[R|r]esetconf(.*)'] = 'configuration_tab/resetconf$1';
$route['RESETCONF(.*)'] = 'configuration_tab/resetconf$1';

$route['[L|l]og_[F|f]iles(.*)'] = 'advanced_tab/log_files$1';
$route['LOG_FILES(.*)'] = 'advanced_tab/log_files$1';

$route['[L|l]icenses(.*)'] = 'advanced_tab/licenses$1';
$route['LICENSES(.*)'] = 'advanced_tab/licenses$1';

$route['[S|s]oftware(.*)'] = 'advanced_tab/software$1';
$route['SOFTWARE(.*)'] = 'advanced_tab/software$1';

$route['[H|h]elp(.*)'] = 'help_tab/help$1';
$route['HELP(.*)'] = 'help_tab/help$1';

$route['[S|s]upport(.*)'] = 'help_tab/support$1';
$route['SUPPORT(.*)'] = 'help_tab/support$1';

$route['[C|c]ontact(.*)'] = 'help_tab/contact';
$route['CONTACT(.*)'] = 'help_tab/contact';



/* End of file routes.php */
/* Location: ./application/config/routes.php */
?>