<?php

if (!defined('BASEPATH'))
  exit('No direct script access allowed');

class Advanced_tab extends MY_Controller {

  public function __construct() {
    parent::__construct();
    $this->load->library('Pages_model');
    $this->load->helper('jsonindent');
    load_lang_d($this,'modelPages');
    load_lang_d($this,'advanced');
    $this->load->library('Software_manager');
  }

  //
  // 'page' functions
  //
  public function software($do='', $file='') {
    $canUpload = $this->session->userdata('userStatus') == 'Admin';
    $data['canUpload'] = $canUpload;
    $data['showImageFileForm'] = '';

    $page = 'software';
    $data['onTab'] = 'advanced';
    $uploadDir = '/tmp/upload/';

    $data['allowAccess'] = true;
    $data['partitions'] = $this->software_manager->getPartitionVersions();
    $data['applications'] = $this->software_manager->getApplicationVersions();
    $data['popShow'] = 'hidden';
    $data['popContent'] = '';

    if ($canUpload && ($do == 'reboot'))
      {
        syslog(LOG_INFO,"User requested reboot\n");
        header("Refresh: 20; url={$this->wwwroot}");
        echo("\n <meta http-equiv=\"refresh\" content=\"20;url={$this->wwwroot}\" />\n");
        echo("<p><br>Unit is rebooting -- browser will reload in 20 seconds.\n");
        echo("<br><br>If reload fails, please click the link below:\n");
        echo("<br><br><a href=\"{$this->wwwroot}\"> {$this->wwwroot}</a>");
        system("rebootDelayed");  // reboot in background after delay
        exit();
      }

    if ($canUpload && ($do == 'img_update') && !empty ($file))
      $data['showImageFileForm'] = $file;

    if ( $canUpload ) {

      $tst_imgSubmitted = 'img_upload' == $do && !empty($file) && !empty($_FILES);
      $tst_appSubmitted = 'app_upload' == $do && isset($_POST['app_submit']) && !empty($_FILES);
      if ($tst_imgSubmitted || $tst_appSubmitted ) {
        $this->session->set_userdata('upload_image', '');
        $this->session->set_userdata('upload_file', '');
        $this->session->set_userdata('upload_name', '');
        $uploadErrors = array();
        $uploadSuccess = '';
        $uploadFile = $uploadDir . basename($_FILES[$do]['tmp_name']);

        if (!empty($_FILES[$do]['tmp_name'])) {
          // save file
          if (!is_dir($uploadDir)) {
            mkdir($uploadDir);
          }
          $this->clear_uploads($uploadDir);
          if (move_uploaded_file($_FILES[$do]['tmp_name'], $uploadFile)) {
            $uploadSuccess = $_FILES[$do]['name'] . lang_x('uploaded_success');
          } else {
            $uploadErrors[] = lang_x('uploaded_fail');
          }
          // verify file
          if ('img_upload' == $do) {
            $verified = $this->software_manager->verifyImageFile($uploadFile, $file);
          } else if ('app_upload' == $do) {
            $verified = $this->software_manager->verifyApplication($uploadFile);
          }
          if ($verified){ // store validated file info for later use
            $this->session->set_userdata('upload_image', $file);
            $this->session->set_userdata('upload_file', $uploadFile);
            $this->session->set_userdata('upload_name', $_FILES[$do]['name']);
          } else { // erase files if not validated
            $this->clear_uploads($uploadDir);
          }

        } else {
          $uploadErrors[] = lang_x('no_file_upload');
        }

        // fill & display pop up
        $data['popShow'] = '';


        if ('img_upload' == $do) {
          $data['popContent'] .= '<h1>' . lang_x('update_image') .': '. lang_x($file);
        } else if ('app_upload' == $do) {
          $data['popContent'] .= '<h1>' . lang_x('update_application');
        }

        $errors = $this->software_manager->get_errors();

        if ($errors) {
          $data['popContent'] .= '</h1><h1 class="failure">' . lang_x('failed');
        } else {
          $data['popContent'] .= '</h1><h1 class="in-progress">' . lang_x('in_progress');
        }

        $data['popContent'] .= '</h1><hr /><div class="pop-msg">';

        if ($uploadErrors) {
          $data['popContent'] .= '<p>'.$uploadSuccess.implode ('<br/>',$uploadErrors).'</p>';
          $data['popContent'].= '<a href="/software" class="btn">OK</a>';
          $this->clear_uploads($uploadDir);
        }


        if ($errors ) {
          $data['popContent'] .= "<p>".lang_x('invalid_file')."</p><p>";
          $data['popContent'] .= $errors.'</p><p>' .  $_FILES[$do]['name'] . ' ' . lang_x('upload_discarded') . '</p>';
          $data['popContent'].= '<a href="/software" class="btn">OK</a>';
          $this->session->set_userdata('upload_image', '');
          $this->session->set_userdata('upload_file', '');
          $this->session->set_userdata('upload_name', '');
          $this->clear_uploads($uploadDir);
        } else if ($uploadSuccess) {
          $target = substr($do,0,3);
          $target_file = !empty($file) ? "$file" : 'current';
          $data['popContent'] .= "<p>";
          $data['popContent'] .= lang_x('about_to_install') . $this->session->userdata('upload_name');
          $data['popContent'] .= "<br><br>" . lang_x('file_will_save');
          $data['popContent'] .= "<br><br>" . lang_x('powerdown_warning');
          $data['popContent'] .= "</p>";
          $data['popContent'] .= "<a class='btn' href='{$this->wwwroot}advanced_tab/software/{$target}_save/{$target_file}'>" . lang_x('continue') . "</a>";
          $data['popContent'] .= "<a class='btn' href='{$this->wwwroot}advanced_tab/software/{$target}_cancel/{$target_file}'>" . lang_x('cancel') . "</a>";
        }
      }

      if ('image_update' == $do && !empty($file) ) {
        echo "<h1>". lang_x('update_image'). ": ". lang_x($file). '</h1><h1 class="in-progress">' . lang_x('in_progress') . "</h1><hr /><div class='pop-msg'>".
          "<form method='post' class='popupForm' enctype='multipart/form-data' action='{$this->wwwroot}advanced_tab/software/img_upload/$file'>".
          "<input type='file' name='img_upload' /> <input type='submit' class='popupSubmit' name='img_submit' value='". lang_x('install'). "'>". "</div>";
        // need to display upload message and show spinner when this form is submitted; div will re-load to kill spinner.
        exit();
      }

      if ('img_save' == $do && !empty($file)  ) {
        if ($this->session->userdata('upload_file') &&  $this->session->userdata('upload_image') == $file ){
          if ( $this->software_manager->installImageFile($this->session->userdata('upload_file'), $file ) ){
            $this->clear_uploads($uploadDir);
            // need to display save confirmation popup
            $data['popShow'] = '';
            if (strpos($this->session->userdata('upload_name'),'application-base') !== false) {
              $data['popContent'] =  "<h1>". lang_x('update_image'). ": ". lang_x($file). '</h1><h1 class="success">' . lang_x('In Progress') . "</h1><hr /><div class='pop-msg'>";
              $data['popContent'] .= '<p>' . lang_x('web server must restart') . '</p>';
            } else {
              $data['popContent'] =  "<h1>". lang_x('update_image'). ": ". lang_x($file). '</h1><h1 class="success">' . lang_x('successful') . "</h1><hr /><div class='pop-msg'>";
              $data['popContent'].= '<p>'. lang_x('image installed') . ' : '. $this->session->userdata('upload_name') .'</p>';
            }
            $data['popContent'].= '<a href="/software" class="btn">OK</a>';
          } else {
            $data['popShow'] = '';
            $data['popContent'] =  "<h1>". lang_x('update_image'). ": ". lang_x($file). '</h1><h1 class="failure">' . lang_x('failed') ."</h1><hr /><div class='pop-msg'>";
            $data['popContent'].= '<p>'. lang_x('image install failed') .'</p><p>';
            $data['popContent'].= $this->software_manager->get_errors() . '</p>' ;
            $data['popContent'].= '<a href="/software" class="btn">OK</a>';
          }
        } else {
          $data['popShow'] = '';
          $data['popContent'] =  "<h1>". lang_x('update_application'). '</h1><h1 class="failure">' . lang_x('failed') ."</h1><hr /><div class='pop-msg'>";
          $data['popContent'].= '<p>'. lang_x('file_gone_missing') . '</p>' ;
          $data['popContent'].= '<a href="/software" class="btn">OK</a>';
        }
      }

      if ('app_save' == $do && 'current' == $file ) {
        if ( $this->session->userdata('upload_file') ){
          if ( strpos($this->session->userdata('upload_name'),'web-user-interface') !== false ) {
            // we're installing the web-user-interface package, so we
            // have to use the package install command that delays for
            // a second and then does it in the background (because
            // the command will have to shutdown the web server)
            if ( $this->software_manager->installApplicationDelayed($this->session->userdata('upload_file') ) ){
              $this->clear_uploads($uploadDir);
              // need to display save confirmation popup
              $data['popShow'] = '';
              $data['popContent'] =  '<h1>' . lang_x('update_application'). '</h1>' .
                '<h1 class="success">' . lang_x('starting install') . '</h1>' .
                '<hr /><div class="pop-msg">';
              $data['popContent'].= '<p>'. $this->session->userdata('upload_name') . ' ' . lang_x('is being installed') . '</p>';
              $data['popContent'].= '<a href="/software" class="btn">OK</a>';
            } else {
              $data['popShow'] = '';
              $data['popContent'] =  "<h1>". lang_x('update_application') . '</h1>' .
                     '<h1 class="failure">' . lang_x('install failed') . "</h1>" .
                     "<hr /><div class='pop-msg'>";
              $data['popContent'].= '<p>' . lang_x('background package install failed') .'</p>';
              $data['popContent'].= '<p>' . $this->software_manager->get_errors() . '</p>' ;
              $data['popContent'].= '<a href="/software" class="btn">OK</a>';
            }
          }
          else {
            // not the web-user-interface package, so we can use the
            // foreground install and wait for the results
            if ( $this->software_manager->installApplication($this->session->userdata('upload_file') ) ){
              $this->clear_uploads($uploadDir);
              // need to display save confirmation popup
              $data['popShow'] = '';
              $data['popContent'] =  "<h1>". lang_x('update_application'). '</h1><h1 class="success">' . lang_x('successful') . "</h1><hr /><div class='pop-msg'>";
              $data['popContent'].= '<p>'. lang_x('package installed') . ' : '. $this->session->userdata('upload_name') .'</p>';
              $data['popContent'].= '<a href="/software" class="btn">OK</a>';
            } else {
              $data['popShow'] = '';
              $data['popContent'] =  "<h1>". lang_x('update_application'). '</h1><h1 class="failure">' . lang_x('failed') ."</h1><hr /><div class='pop-msg'>";
              $data['popContent'].= '<p>'. lang_x('package install failed') .'</p><p>';
              $data['popContent'].= $this->software_manager->get_errors() . '</p>' ;
              $data['popContent'].= '<a href="/software" class="btn">OK</a>';
            }
          }
        } else {
          $data['popShow'] = '';
          $data['popContent'] =  "<h1>". lang_x('update_application'). '</h1><h1 class="failure">' . lang_x('failed') ."</h1><hr /><div class='pop-msg'>";
          $data['popContent'].= '<p>'. lang_x('file_gone_missing') . '</p>' ;
          $data['popContent'].= '<a href="/software" class="btn">OK</a>';
        }
      }

      if ('app_cancel' == $do || 'img_cancel' == $do ) {
        $this->clear_uploads($uploadDir);
      }
    }

    $this-> _view_page($page, $data);
  }

  private function clear_uploads($uploadDir){
    $uploadDirFiles = scandir($uploadDir);
    foreach ($uploadDirFiles as $oldFile) {
      if (substr($oldFile,0,1)=='.')
        continue;
      unlink($uploadDir . $oldFile);
    }
  }

  public function log_files($do='', $file='') {
    $page = 'log_files';
    $data['onTab'] = 'advanced';
    $canClear = $this->session->userdata('userStatus') == 'Admin';
    $data['canClear'] = $canClear;
    $data['listLogFiles'] = $this->software_manager->listLogFiles();
    $data['allowAccess'] = true;

    if ('get' === $do && !empty($file)) {
      echo "<span class='log-file-title'>$file</span>";
      $log = $this->software_manager->getLogFile($file);
      if ($log) {
        echo "<pre class='log-file-data'>" . $this->software_manager->getLogFile($file) . "</pre>";
      } else {
        echo "<pre class='log-file-error'>Error:" . $this->software_manager->get_errors() . "</pre>";
      }
      exit();
    }

    if ($canClear && ('clear' === $do && !empty($file))) {
      $result = $this->software_manager->clearLogFile($file);
      if ($result) {
        echo "<pre class='log-file-success'>'$file' " . lang_x('file_cleared_success');
      } else {
        echo $$this->software_manager->get_errors();
      }
      exit();
    }

    if ('export' === $do && !empty($file)) {
      $log = $this->software_manager->getLogFile($file);
      if ($log) {
        // do the actual download
        $file_name = "{$file}_" . date("Y_m_j_Hi") . '.txt';
        header("Expires: Sat, 01 Jan 2000 00:00:00 GMT");
        header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
        header("Pragma: public");
        header("Expires: 0");
        header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
        header("Cache-Control: public");
        header("Content-Description: File Transfer");
        session_cache_limiter("must-revalidate");
        header("Content-Type: application/text");
        header("Content-Disposition: attachment; filename=\"$file_name\"");
        session_start();
        echo $this->software_manager->getLogFile($file);
      } else {
        echo "
                  <h1>Error:<h1><h2>" . $this->software_manager->get_errors() . "</h2>";
      }
      exit();
    }

    $this->_view_page($page, $data);
  }

  public function licenses($do='', $file='') {
    $page = 'licenses';
    $data['onTab'] = 'advanced';
    $data['allowAccess'] = true;
    $this->_view_page($page, $data);
  }


  //
  // 'utility' functions
  //
  protected function _view_page($page, $data) {
    $this->_view_dir_page('advanced_tab', $page, $data);
  }
}

?>