<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Configuration_tab extends MY_Controller {

	public function __construct() {
        parent::__construct();

        $this->load->library('Pages_model');
        $this->load->helper('jsonindent');
        load_lang_d($this,'modelPages');
        load_lang_d($this,'network');
    }

    //
    // 'port' specific configuration functions
    //
    public function port_settings($ports = 'all') {
    	load_lang_d($this,'ports');
        $data['canEdit'] = in_array($this->session->userdata('userStatus'), array('Admin', 'Operator'));

        $portInfo = $this->pages_model->pages['port_config'];
        $portInfo->load();
        $data['pageData'] = &$portInfo;
        $this->numPorts = $portInfo->get_numPorts();

        $data['allPorts'] = '';
        for ($i = 1; $i < $this->numPorts; $i++) {
            $data['allPorts'] .= "$i.";
        }
        $data['allPorts'] .= $this->numPorts;

        $page = 'port_settings';
        $data['onTab'] = 'configuration';

        if ($this->session->userdata('userStatus'))
            $data['allowAccess'] = true; // login required to access
        $data['ports'] = $ports;

        $this->_view_page($page, $data);
    }

    public function ethernetip_settings($ports = 'all') {
    	load_lang_d($this,'ports');
        $data['canEdit'] = in_array($this->session->userdata('userStatus'), array('Admin', 'Operator'));

        $portInfo = $this->pages_model->pages['ethernetip_config'];
        $portInfo->load();
        $data['pageData'] = &$portInfo;
        $this->numPorts = $portInfo->get_numPorts();

        $data['allPorts'] = '';
        for ($i = 1; $i < $this->numPorts; $i++) {
            $data['allPorts'] .= "$i.";
        }
        $data['allPorts'] .= $this->numPorts;

        $page = 'ethernetip_settings';
        $data['onTab'] = 'configuration';

        if ($this->session->userdata('userStatus'))
            $data['allowAccess'] = true; // login required to access
        $data['ports'] = $ports;

        $this->_view_page($page, $data);
    }

    public function modbustcp_settings($ports = 'all') {
      	load_lang_d($this,'ports');
        $data['canEdit'] = in_array($this->session->userdata('userStatus'), array('Admin', 'Operator'));

        $portInfo = $this->pages_model->pages['modbustcp_config'];
        $portInfo->load();
        $data['pageData'] = &$portInfo;
        $this->numPorts = $portInfo->get_numPorts();

        $data['allPorts'] = '';
        for ($i = 1; $i < $this->numPorts; $i++) {
            $data['allPorts'] .= "$i.";
        }
        $data['allPorts'] .= $this->numPorts;

        $page = 'modbustcp_settings';
        $data['onTab'] = 'configuration';

        if ($this->session->userdata('userStatus'))
            $data['allowAccess'] = true; // login required to access
        $data['ports'] = $ports;

        $this->_view_page($page, $data);
    }
/*
     * Ajax handler - returns set of <li> values for a given port
     */
    public function ajax_port_reload($port=0) {
    	// test only
    	//syslog(LOG_INFO, "ajax_port_reload(), port $port\n");

    	$portInfo = $this->pages_model->pages['port_config'];
        $portInfo->load();
        $this->numPorts = $portInfo->get_numPorts();
        $port = (int)$port;
        if (1 > $port || $port > $this->numPorts || !in_array($this->session->userdata('userStatus'), array('Admin', 'Operator')) ){
            exit('error loading port information');
        } else {
            echo $portInfo->get_port_column($port-1, $this->numPorts);
        }
    }

    /*
     * Ajax handler - returns set of <li> values for a given port in edit mode
     */
    public function ajax_port_edit_form($port=0) {
	   	// test only
    	//syslog(LOG_INFO, "ajax_port_edit_form(), port $port\n");

     	$portInfo = $this->pages_model->pages['port_config'];
        $portInfo->load();
        $this->numPorts = $portInfo->get_numPorts();
        $port = (int)$port;
        if (1 > $port || $port > $this->numPorts || !in_array($this->session->userdata('userStatus'), array('Admin', 'Operator')) ){
            exit('error loading port information');
        } else {
            echo "<form id='form_port_$port' method='post' action='{$this->wwwroot}configuration_tab/ajax_port_save/$port'>",
                $portInfo->get_port_column_edit($port-1, $this->numPorts),
                "</form>";
        }
    }

    /*
     * Ajax handler - to save / validate port form submission
     */
    public function ajax_port_save($port=0){
     	$params = array();
        $form = $_POST['form'];
        parse_str($form, $params);

        foreach ($params as $key=>$val)
        {
            $_POST[$key] = $val;
        }

	   	// test only
        //syslog(LOG_INFO, "ajax_port_save(), port $port\n");

    	$saved = false;
        $portInfo = $this->pages_model->pages['port_config'];
        $portInfo->load();
        $portInfo->update_from_post($port-1);
        $this->numPorts = $portInfo->get_numPorts();
        $port = (int)$port;
        if (1 > $port || $port > $this->numPorts || !in_array($this->session->userdata('userStatus'), array('Admin', 'Operator')) ){
            exit('error loading port information');
        } else {
            if ( $portInfo->validate($port-1) ) {
                    if ( $portInfo->save($port-1) ){
                        $saved = true;
                    }
            } else {
                $saved = false;
            }
        }
        if ($saved){
            echo "<ul id='port-list-{$port}'>", $portInfo->get_port_column($port-1, $this->numPorts), "</ul>";
        } else {
            echo '',
                    "<ul id='port-list-{$port}'>",
                    "<form id='form_port_$port' method='get' action='{$this->wwwroot}configuration_tab/ajax_port_save/$port'>",
                    $portInfo->get_port_column_edit($port-1, $this->numPorts),
                    "</form></ul>";
        }
    }

    public function ajax_ethernetip_reload($port=0) {
    	// test only
    	//syslog(LOG_INFO, "ajax_ethernetip_reload(), port $port\n");

    	$portInfo = $this->pages_model->pages['ethernetip_config'];
        $portInfo->load();
        $this->numPorts = $portInfo->get_numPorts();
        $port = (int)$port;
        if (1 > $port || $port > $this->numPorts || !in_array($this->session->userdata('userStatus'), array('Admin', 'Operator')) ){
            exit('error loading port information');
        } else {
            echo $portInfo->get_port_column($port-1, $this->numPorts);
        }
    }

    public function ajax_ethernetip_edit_form($port=0){
    	// test only
    	//syslog(LOG_INFO, "ajax_ethernetip_edit_form(), port $port\n");

    	$portInfo = $this->pages_model->pages['ethernetip_config'];
    	$portInfo->load();
    	$this->numPorts = $portInfo->get_numPorts();
    	$port = (int)$port;
    	if (1 > $port || $port > $this->numPorts || !in_array($this->session->userdata('userStatus'), array('Admin', 'Operator')) ){
    		exit('error loading port information');
    	} else {
    		echo "<form id='form_enetip_$port' method='post' action='{$this->wwwroot}configuration_tab/ajax_ethernetip_save/$port'>",
    		$portInfo->get_port_column_edit($port-1, $this->numPorts),
    		"</form>";
    	}
    }

    public function ajax_ethernetip_save($port=0){
    	$params = array();
    	$form = $_POST['form'];
    	parse_str($form, $params);

    	foreach ($params as $key=>$val)
    	{
    		$_POST[$key] = $val;
    	}
    	// test only
    	//syslog(LOG_INFO, "ajax_ethernetip_save(), port $port, schema $this->active_schema_page\n");

    	$saved = false;
    	$portInfo = $this->pages_model->pages['ethernetip_config'];
    	$portInfo->load();
    	$portInfo->update_from_post($port-1);
    	$this->numPorts = $portInfo->get_numPorts();
    	$port = (int)$port;
    	if (1 > $port || $port > $this->numPorts || !in_array($this->session->userdata('userStatus'), array('Admin', 'Operator')) ){
    		exit('error loading port information');
    	} else {
    		if ( $portInfo->validate($port-1) ) {
    			if ( $portInfo->save($port-1) ){
    				$saved = true;
    			}
    		} else {
    			$saved = false;
    		}
    	}
    	if ($saved){
    		echo "<ul id='port-list-{$port}'>", $portInfo->get_port_column($port-1, $this->numPorts), "</ul>";
    	} else {
    		echo '',
    		"<ul id='port-list-{$port}'>",
    		"<form id='form_enetip_$port' method='get' action='{$this->wwwroot}configuration_tab/ajax_ethernetip_save/$port'>",
    		$portInfo->get_port_column_edit($port-1, $this->numPorts),
     		"</form></ul>";
    	}
    }

    public function ajax_modbustcp_reload($port=0) {
    	// test only
    	//syslog(LOG_INFO, "ajax_modbustcp_reload(), port $port, schema $this->active_schema_page\n");

    	$portInfo = $this->pages_model->pages['modbustcp_config'];
        $portInfo->load();
        $this->numPorts = $portInfo->get_numPorts();
        $port = (int)$port;
        if (1 > $port || $port > $this->numPorts || !in_array($this->session->userdata('userStatus'), array('Admin', 'Operator')) ){
            exit('error loading port information');
        } else {
            echo $portInfo->get_port_column($port-1, $this->numPorts);
        }
    }

    public function ajax_modbustcp_edit_form($port=0){
    	// test only
    	//syslog(LOG_INFO, "ajax_modbustcp_edit_form(), port $port, schema $this->active_schema_page\n");

    	$portInfo = $this->pages_model->pages['modbustcp_config'];
    	$portInfo->load();
    	$this->numPorts = $portInfo->get_numPorts();
    	$port = (int)$port;
    	if (1 > $port || $port > $this->numPorts || !in_array($this->session->userdata('userStatus'), array('Admin', 'Operator')) ){
    		exit('error loading port information');
    	} else {
    		echo "<form id='form_mbtcp_$port' method='post' action='{$this->wwwroot}configuration_tab/ajax_modbustcp_save/$port'>",
    		$portInfo->get_port_column_edit($port-1, $this->numPorts),
    		"</form>";
    	}
  	}

   public function ajax_modbustcp_save($port=0){
    	$params = array();
    	$form = $_POST['form'];
    	parse_str($form, $params);

	   	// test only
    	//syslog(LOG_INFO, "ajax_modbustcp_save(), action $action, port $port, schema $this->active_schema_page\n");

    	foreach ($params as $key=>$val)
    	{
    		$_POST[$key] = $val;
    	}

    	$saved = false;
    	$portInfo = $this->pages_model->pages['modbustcp_config'];
    	$portInfo->load();
    	$portInfo->update_from_post($port-1);
    	$this->numPorts = $portInfo->get_numPorts();
    	$port = (int)$port;
    	if (1 > $port || $port > $this->numPorts || !in_array($this->session->userdata('userStatus'), array('Admin', 'Operator')) ){
    		exit('error loading port information');
    	} else {
    		if ( $portInfo->validate($port-1) ) {
    			if ( $portInfo->save($port-1) ){
    				$saved = true;
    			}
    		} else {
    			$saved = false;
    		}
    	}
    	if ($saved){
    		echo "<ul id='port-list-{$port}'>", $portInfo->get_port_column($port-1, $this->numPorts), "</ul>";
    	} else {
    		echo '',
    		"<ul id='port-list-{$port}'>",
    		"<form id='form_mbtcp_$port' method='get' action='{$this->wwwroot}configuration_tab/ajax_modbustcp_save/$port'>",
    		$portInfo->get_port_column_edit($port-1, $this->numPorts),
    		"</form></ul>";
    	}
    }
  /////

    public function network($action='') {

        $canEdit = $this->session->userdata('userStatus') == 'Admin';
        $data['canEdit'] = $canEdit;
        $data['action'] = strtolower($action);

        if ('reset' == $data['action']) {
            // TODO - do reset stuff
        }
        if ('ledflashon' == $data['action']) {
            exec("demoapp -f 1");
        }
        if ('ledflashoff' == $data['action']) {
            exec("demoapp -f 0");
        }

        $networkInfo = $this->pages_model->pages['network_config'];
        $networkInfo->load();

        if ( $canEdit && $this->session->userdata('userStatus') && array_key_exists('save', $_POST)) 
          {
            // user has submitted network config form
            $old_IPv4address = $networkInfo->json['network']['IPv4address'];
            $networkInfo->update_from_post();
            if ($networkInfo->validate()) 
              {
                if ($networkInfo->save()) 
                  {
                    $new_IPv4address = $networkInfo->json['network']['IPv4address'];
                    if ($new_IPv4address != $old_IPv4address)
                      {
                        // user is changing IP address
                        syslog(LOG_INFO,"IP address changed: redirecting to new IP address\n");
                        header("Refresh: 2; url=http://$new_IPv4address/index.php/Network");
                        echo("\n <meta http-equiv=\"refresh\" content=\"2;url=http://$new_IPv4address/index.php/Network\" />\n");
                        echo("<p><br><br>Redirecting to new IP address in 2 seconds.  If that doesn't work, please click the link below:\n");
                        echo("<br><br><a href=\"http://$new_IPv4address/index.php/Network\"> http://$new_IPv4address/index.php/Network</a>.");
                      }
                    else
                      header("location: /Network");
                    exit();
                  }
              }
          }

        $page = 'network';
        if ($this->session->userdata('userStatus')) $data['allowAccess'] = true;
        $data['onTab'] = 'configuration';
        $data['networkInfo'] = &$networkInfo;
        $this->_view_page($page, $data);
    }


    public function resetconf($action='') 
    {
      syslog(LOG_INFO,"resetconf($action) called\n");
      $data['action'] = strtolower($action);
      $canClear = $this->session->userdata('userStatus') == 'Admin';

      if (!$canClear)
        {
          header("Location: /Home");
          exit();
        }

      if ($action == 'clear')
        {
          syslog(LOG_INFO,"User requested configuration reset\n");
          exec('clear_config');
        }

      $page = 'resetconf';
      if ($this->session->userdata('userStatus')) $data['allowAccess'] = true;
      $data['onTab'] = 'configuration';
      $this->_view_page($page, $data);
    }


    //
    // 'utility' functions
    //
    protected function _view_page($page, $data) {
        $this->_view_dir_page('configuration_tab', $page, $data);
    }

}
?>
