<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Diagnostics_tab extends MY_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->library('Pages_model');
        $this->load->helper('jsonindent');
        load_lang_d($this,'modelPages');
        load_lang_d($this,'diagnostics');
    }

    //
    // 'page' functions
    //

    public function ethernet($action=null) {
        $page = 'ethernet';
        $data['onTab'] = 'diagnostics';
        $data['action'] = strtolower($action);

        if ($this->session->userdata('userStatus')){
            $data['allowAccess'] = true;
            $ethernetInfo = $this->pages_model->pages['ethernetip_diag'];
            $ethernetInfo->load();
            $data['ethernetInfo'] = &$ethernetInfo;
        	$this->numPorts = $ethernetInfo->get_numPorts();
        } else {
        	exit;
        }
        if ('reload' == $action) {
             echo $ethernetInfo->view_value_table();
             exit;
         }

         if ('reloadport' == $action) {
             echo $ethernetInfo->get_value_port_rows();
             exit;
         }

         if ('reset' == $action) {
             $ethernetInfo->reset();
             echo $ethernetInfo->view_value_table();
             exit;
         }

        $this->_view_page($page, $data);
    }

    public function modbus($action=null) {
        $page = 'modbus';
        $data['onTab'] = 'diagnostics';
        $data['action'] = strtolower($action);

        if ($this->session->userdata('userStatus')) {
            $data['allowAccess'] = true;
            $modbusInfo = $this->pages_model->pages['modbus_diag'];
            $modbusInfo->load();
            $data['modbusInfo'] = &$modbusInfo;
        	$this->numPorts = $modbusInfo->get_numPorts();
        } else {
        	exit;
        }

         if ('reload' == $action) {
             echo $modbusInfo->view_value_table();
             exit;
         }

         if ('reloadport' == $action) {
             echo $modbusInfo->get_value_port_rows();
             exit;
         }
         if ('reset' == $action) {
             $modbusInfo->reset();
             echo $modbusInfo->view_value_table();
             exit;
         }

        $this->_view_page($page, $data);
    }

    public function ports($action=null,$port=null) {
        // test only
    	//syslog(LOG_INFO, "ports(), action $action, port $port\n");
    	load_lang_d($this,'ports');
        $data['onTab'] = 'diagnostics';
        $page = 'ports';
        $data['action'] = strtolower($action);
        // HBB - added 11/13/12
        $portInfo=null;
        if ($this->session->userdata('userStatus')) {
            $data['allowAccess'] = true;
            $portInfo = $this->pages_model->pages['iolink_diag'];
            $portInfo->load();
            $data['portInfo'] = &$portInfo;
            $this->numPorts = $portInfo->get_numPorts();
        } else {
        	exit;
        }

        if ('reload' == $action) {
        	echo $portInfo->get_value_port_rows();
        	exit;
        }
        if ('reset' == $action) {
        	$portInfo->reset();
        	echo $portInfo->get_value_port_rows();
        	exit;
        }
 
        $this->_view_page($page, $data);
    }

    //
    // 'utility' functions
    //
    protected function _view_page($page, $data) {
        $this->_view_dir_page('diagnostics_tab', $page, $data);
    }

}
?>
