<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class MY_Controller extends CI_Controller {

  public function __construct() {

    parent::__construct();
    $this->load->library('Session');
    $this->code_version = 'dev_0.26'; // should be set to dev_0.CURRENT_SVN_VERSION before updating preview
    $this->updaterate = 30 * 1000 ; // default update twice a minut
    $this->defaultLanguage = 'english';
    $this->load->helper('language');

    switch ($_SERVER['SERVER_PORT']) 
      {
      case '443':
      case '8443':
        $proto = 'https';
        break;
      default:
        $proto = 'http';
        break;
      }

    $this->assets =  $proto . '://' . $_SERVER['HTTP_HOST'] . '/assets/';
    $this->wwwroot = $proto . '://' . $_SERVER['HTTP_HOST'] . '/index.php/';
  }

    protected function _view_dir_page($dir, $page, $data){
        // set language
        if ( !$this->session->userdata('language') ){
            $this->session->set_userdata('language', $this->defaultLanguage);
        }
        if (isset($_POST['language'])) {
            $this->session->set_userdata('language',$_POST['language']) ;
        }

        //  // vars for use in page
        $data['wwwroot'] = $this->wwwroot;

        $data['page'] = $page;
        $data['userStatus'] = $this->session->userdata('userStatus'); // var for use in page
        $data['code_version'] = $this->code_version;
        $data['language'] = $this->session->userdata('language');


        if (  !(array_key_exists('allowAccess',$data) && $data['allowAccess']) && $page != 'login') { // go to login page if not logged / authorized
            header("Location: {$this->wwwroot}login");
            exit();
        }
        unset($data['allowAccess']);
        // put together the page view

        $this->load->view('templates/navbar_header',$data);
        $this->load->view($dir.'/'.$page,$data);
        $this->load->view('templates/footer',$data);
    }

}
?>