<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once "Pages_model/Page.php";
require_once "Pages_model/Field.php";

/**
 * This is the base class for the pages data model. It contains all the schemas for page models.
 */
class Pages_model {
  public $pages;  // array[pagename] of Page
  static $num_ports;

  /**
   * This loads the data model schema from the "pages_schema" JSON file.
   */
  public function __construct()
  {
    $this->pages = Array();
    $json_file=file_get_contents("assets/json/pages_schema.json");
    if ($json_file) {
      $json_array=json_decode($json_file,true);
      if (!$json_array) throw new Exception('Error reading pages_schema.json');
      self::$num_ports=array_key_exists('num_ports',$json_array) ? $json_array['num_ports'] : 4;
      foreach ($json_array['pages'] AS $pagename=>$page_json) {
        $this->pages[$pagename]=new Page($page_json,$pagename);
      }
    }
  }


  /**
   * This is a test function to dump out the contents of the pages data schema
   */
  public function schema_table()
  {
    echo "<table border=1>\n";
    foreach ($this->pages AS $pagename=>$page) {
      echo "<tr><td colspan=9><h1>page: $pagename</h1></td></tr>";
      $page->schema_table();
    }
    echo "</table>\n";
  }
}
?>
