<?php
$onTab = empty($onTab) ? false : $onTab;

 load_lang_d($this,'accounts', $language);
 load_lang_d($this,'head', $language) ;
 load_lang_d($this,'navTabs', $language) ;
 load_lang_d($this,'navPages', $language) ;

 $page_help_url = array(
     "ports"    => "/assets/WebHelp/diagnostics/io-link_(diagnostics).htm",
     "ethernet" => "/assets/WebHelp/diagnostics/ethernet_ip_(diagnostics).htm",
     "modbus"   => "/assets/WebHelp/diagnostics/modbus_tcp_(diagnostics).htm",
     "port_settings" => "/assets/WebHelp/configuration/io-link_settings.htm",
     "ethernetip_settings" => "/assets/WebHelp/configuration/ethernet_ip_settings.htm",
     "modbustcp_settings" => "/assets/WebHelp/configuration/modbus_tcp_settings.htm",
     "network" => "/assets/WebHelp/configuration/network.htm",
     "resetconf" => "/assets/WebHelp/configuration/clear_settings.htm",
     "software"  => "/assets/WebHelp/advanced/software.htm",
     "advanced_accounts" => "/assets/WebHelp/advanced/accounts.htm",
     "log_files" => "/assets/WebHelp/advanced/log_files.htm",
     "support"   => "/assets/WebHelp/support.htm",
    );

$loginMsg = '';
switch($userStatus){
    case 'NEW':
        $loginMsg = "$userStatus - Click 'Login' for Installation Wizard";
        break;
    case 'Admin':
    case 'Operator':
    case 'User':
        $loginMsg = lang_x('logged_in_as').lang_x($userStatus);
        break;
    default:
        $loginMsg = lang_x("not_logged_in");
        break;
}

?>
<!DOCTYPE html>
<html>
<!-- START HEAD SECTION - template used on every page -->
<head>
  <title><?php echo lang('page_title_prefix'), lang_d('page_'.$page) ?></title>
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <link rel="stylesheet" type="text/css" href="<?php echo $this->assets ?>styles/base.css?<?php echo $code_version ?>" />
  <!-- <link rel="stylesheet" type="text/css" href="<?php echo $this->assets ?>styles/invert/invert.css?<?php echo $code_version ?>" /> -->
    <script type="text/javascript" src="<?php echo $this->assets ?>javascript/jQuery_v1.8.2.js"></script>
    <script type="text/javascript" src="<?php echo $this->assets ?>javascript/config.js?<?php echo $code_version ?>"></script>
</head>
<body>
  <div id="master-contain">
    <div id="header">
      <div id="logo">
        <a href="/" class="ir">Comtrol</a>
      </div>
<?php if ($userStatus){ ?>
                        <div id="navigation">
        <ul>
          <li<?php echo $onTab == 'home' ? ' class="active"' : ''; ?>><a href="<?php echo "{$wwwroot}home" ?>"><?php echo lang('tab_home') ?></a></li>
          <li<?php echo $onTab == 'diagnostics' ? ' class="active"' : ''; ?>><a href="<?php echo "{$wwwroot}Ports/Diag" ?>"><?php echo lang('tab_diagnostics') ?></a>
            <ul class="subnav<?php echo $onTab == 'diagnostics' ? ' sub-active' : ''; ?>">
              <li<?php echo $page=='ports'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Ports/Diag" ?>"><?php echo lang('page_iolink_diag') ?></a></li>
              <li<?php echo $page=='ethernet'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}EtherNet/IP/Diag" ?>"><?php echo lang('page_ethernetip_diag') ?></a></li>
              <li<?php echo $page=='modbus'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}ModBus/TCP/Diag" ?>"><?php echo lang('page_modbustcp_diag') ?></a></li>
            </ul>
          </li >
          <li<?php echo $onTab == 'configuration' ? ' class="active"' : ''; ?>><a href="<?php echo "{$wwwroot}Ports/Settings" ?>"><?php echo lang('tab_configuration') ?></a>
            <ul class="subnav<?php echo $onTab == 'configuration' ? ' sub-active' : ''; ?>">
              <li<?php echo $page=='port_settings'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Ports/Settings" ?>"><?php echo lang('page_iolink_settings') ?></a></li>
              <li<?php echo $page=='ethernetip_settings'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Ethernet/IP/Settings" ?>"><?php echo lang('page_ethernetip_settings') ?></a></li>
              <li<?php echo $page=='modbustcp_settings'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Modbus/TCP/Settings" ?>"><?php echo lang('page_modbustcp_settings') ?></a></li>
              <li<?php echo $page=='network'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Network" ?>"><?php echo lang('page_network') ?></a></li>
              <?php if ('Admin' == $userStatus) { ?>
                <li<?php echo $page=='resetconf'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Resetconf" ?>"><?php echo lang('page_clear_settings') ?></a></li>
              <?php } ?>
            </ul>
          </li>
          <li<?php echo $onTab == 'advanced' ? ' class="active"' : ''; ?>><a href="<?php echo "{$wwwroot}Software" ?>"><?php echo lang('tab_advanced') ?></a>
            <ul class="subnav<?php echo $onTab == 'advanced' ? ' sub-active' : ''; ?>">
              <li<?php echo $page=='software'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Software" ?>"><?php echo lang('page_software') ?></a></li>
              <?php if ('Admin' == $userStatus) { ?>
                <li<?php echo $page=='advanced_accounts'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Accounts" ?>"><?php echo lang('page_advanced_accounts') ?></a></li>
              <?php } ?>
              <li<?php echo $page=='log_files'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Log_Files" ?>"><?php echo lang('page_log_files') ?></a></li>
              <li<?php echo $page=='licenses'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Licenses" ?>"><?php echo lang('page_licenses') ?></a></li>
            </ul>
          </li>
          <li<?php echo $onTab == 'help' ? ' class="active"' : ''; ?>><a href="<?php echo "{$wwwroot}Help" ?>"><?php echo lang('tab_help') ?></a>
            <ul class="subnav<?php echo $onTab == 'help' ? ' sub-active' : ''; ?>">
              <li<?php echo $page=='help'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Help" ?>"><?php echo lang('page_help') ?></a></li>
              <li<?php echo $page=='support'?' class="subnav-active"':''; ?>><a href="<?php echo "{$wwwroot}Support" ?>"><?php echo lang('page_support') ?></a></li>
                                                        <li<?php echo $page=='contact'?' class="subnav-active"':''; ?> ><a href="<?php echo "{$wwwroot}Contact" ?>"><?php echo lang('page_contact') ?></a></li>
            </ul>
          </li>
        </ul>
      </div>
<?php } ?>
      <div id="logged-in">
        <p class="logged-in-message"><?php echo $loginMsg ?></p>
        <div id="logged-in-links">
          <a class="altnav first nav-logout" href="<?php echo "{$wwwroot}logout"; ?>"><?php echo lang('logout') ?></a>
          <a class="altnav nav-contact" href="<?php echo "{$wwwroot}contact"; ?>"><?php echo lang('contact') ?></a>
          <div class="lang-selector">
                <div class="lang-current">
                  <a href="#" title="english" class="us"><img src="/assets/images/flags/us.png" alt="" /></a>
                </div>
            <a href="#" class="lang-toggle"></a>
              </div><!-- .lang-selector -->
                      <form method="post" id="lang_form" class="hidden">
                          <select name="language" onchange="document.forms['lang_form'].submit();">
                              <option value="english"<?php echo $language=='english' ? ' selected="selected"' : '' ?> ><?php echo lang_x('english') ?></option>
                              <option value="spanish"<?php echo $language=='spanish' ? ' selected="selected"' : '' ?> ><?php echo lang_x('spanish') ?></option>
                          </select>
                      </form>
        </div><!-- #logged-in-links -->
      </div><!-- #logged-in -->


                    </div><!-- close header -->
          <div class="lang-list">
              <a href="#" title="English" class="english"><img src="/assets/images/flags/us.png" alt="" /></a>
              <a href="#" title="Spanish" class="spanish"><img src="/assets/images/flags/mx.png" alt="" /></a>
              <a href="#" title="French" class="french"><img src="/assets/images/flags/fr.png" alt="" /></a>
              <a href="#" title="Russian" class="russian"><img src="/assets/images/flags/ru.png" alt="" /></a>
            </div>
                        <div id="content-contain">
                            <div id="main-content">

<?php
 #
 # echo "<! $page >";
 if (array_key_exists($page, $page_help_url))
   {
     $url = $page_help_url[$page]; 
     echo "<a href='$url'><img src='/assets/images/question_16.png' alt='page-specifc-help'></a>";
   }
?>
