var portOpen = 231; //border adds a pixel
var portClosed = 35;
var portHeadOpen = portOpen - 20;
var portHeadClosed = portClosed - 20;
var portHeaderEdit = [];
var buildUrl = [];

$(document).ready(function(){
	var maxPortHeight = $('.port:first').height();
	var ie7 = $.browser.msie == true && $.browser.version == '7.0';
	var ie8 = $.browser.msie == true && $.browser.version == '8.0';
	var lang = $('#lang_form').find('option:selected');
	var logo = $('#logo');
	var nav = $('#navigation');
	var li = $('#logged-in');
	var cur, curClass, updatedLang;

	if(ie8){
		$('html').addClass('ie8');
	}

	checkLang(lang);
	stickyLang();

	//dynamically set width of ports based on container size
	setPortWidth();

	//auto open/close appropriate ports and add dynamic heights
	checkportStatus();

	//determine ports to be opened in edit mode
	buildURL();

	//if file upload input is empty disable the form
	disableEmptyFileInputs();

	//add hover text to sidebar labels
	$('#sidebar').find('.sub-info').each(function(){
		$(this).attr('title', $(this).text());
	});

	$(window).resize(function(){
		stickyLang();
		setPortWidth();
		checkportStatus();
	});

	// $('#logged-in').css({
	// 	'left':$('#logo').width() + $('#navigation').width() + 40
	// });

	$('#master-contain').css({
		//'min-width':nav.width() + logo.width() + li.width() + 105
	});

    $('.port-head').on('click', '.save-btn', function(){
		var portNum0 = $(this).closest('.port-head').attr('port-number');
		var portNum = portNum0
		var editingPort = $('.port').eq(portNum0);
		var formData = $('#form_port_' + portNum).serialize();

		$.ajax({
		        type: "POST",
		        url: "../../index.php/configuration_tab/ajax_port_save/" + portNum,
		        data: {'form': formData},
		        success: function(e){
		            editingPort.find('.port-content').html(e);
		        },
		        complete:function(){
		            set_port_btns(portNum);

		            var portList = editingPort.find('.port-content').children('ul');

		            $('.hidden-toggle').each(function(index){
		                index = index + 1;
		                var isVisible = $(this).parent().siblings('.hide-' + index).is(':visible');

		                if(isVisible){
		                    portList.find('.hide-' + index).show();
		                }
		            });
		        }
		});

    	return false;
    });

    $('.port-head').on('click', '.enetip-save-btn', function(){
		var portNum0 = $(this).closest('.port-head').attr('port-number');
		var portNum = portNum0;
		var editingPort = $('.port').eq(portNum0);
		var formData = $('#form_enetip_' + portNum).serialize();

		$.ajax({
		        type: "POST",
		        url: "../../configuration_tab/ajax_ethernetip_save/" + portNum,
		        data: {'form': formData},
		        success: function(e){
		            editingPort.find('.port-content').html(e);
		        },
		        complete:function(){
		            set_enetip_port_btns(portNum);

		            var portList = editingPort.find('.port-content').children('ul');

		            $('.hidden-toggle').each(function(index){
		                index = index + 1;
		                var isVisible = $(this).parent().siblings('.hide-' + index).is(':visible');

		                if(isVisible){
		                    portList.find('.hide-' + index).show();
		                }
		            });
		        }
		});

    	return false;
    });

    $('.port-head').on('click', '.mbtcp-save-btn', function(){
		var portNum0 = $(this).closest('.port-head').attr('port-number');
		var portNum = portNum0;
		var editingPort = $('.port').eq(portNum0);
		var formData = $('#form_mbtcp_' + portNum).serialize();

		$.ajax({
		        type: "POST",
		        url: "../../configuration_tab/ajax_modbustcp_save/" + portNum,
		        data: {'form': formData},
		        success: function(e){
		            editingPort.find('.port-content').html(e);
		        },
		        complete:function(){
		            set_mbtcp_port_btns(portNum);

		            var portList = editingPort.find('.port-content').children('ul');

		            $('.hidden-toggle').each(function(index){
		                index = index + 1;
		                var isVisible = $(this).parent().siblings('.hide-' + index).is(':visible');

		                if(isVisible){
		                    portList.find('.hide-' + index).show();
		                }
		            });
		        }
		});

    	return false;
    });

    $(document).keyup(function(e){
		if(e.keyCode == 27){
			closePopup();
		}
	});

	$('body').on('click', function(){
		$('.lang-list').slideUp(100);
	});

	$('#softpop').on('click', '.close-popup', closePopup);

	$('.lang-toggle, .lang-list').on('click', function(){
		$('.lang-list').slideToggle(200);

		return false;
	});

	$('input[type="submit"][value="Install"]').closest('form').submit(function(){
		// $(this).parent('div').append('<img src="/assets/images/loader.gif" alt="Loading..." />');
		$(this).fadeOut('fast', function(){
			$(this).html('<div class="loading"><img src="/assets/images/loader.gif" alt="" class="spindicator fl" /><h1 class="fl">Installing...</h1></div>').fadeIn();
		});
	});

	$('#softpop').on('submit', '.popupForm', function(e){
		$(this).fadeOut('fast').parent().html('<div class="loading"></div>');
	});

	$('body').on('change', 'input[type="file"]', disableEmptyFileInputs);

	$('.lang-list a').on('click', function(){
		cur = $(this);
		curClass = cur.attr('class');
		updatedLang = $('#lang_form').find('option[value="'+ curClass +'"]');
		lang = updatedLang;

		$('#lang_form').find('option').removeAttr('selected');

		updatedLang.attr('selected', 'selected');
		checkLang(lang);

		$('.lang-list').slideUp(100, function(){
			$('#lang_form').trigger('submit');
		});

		return false;
	});

	$('.lang-current').on('click', function(){
		var ll = $('.lang-list');

		ll.slideToggle('fast');

		return false;
	});

	//hook up image replacement for port toggle checkbox
	$('.close-port, .open-port').on('click', function(){
		var trigger = $(this).siblings('.port-toggle');
		var portToggle = $(this).siblings('.port-toggle');

		$(portToggle).click();

		openClosePorts(trigger);

		return false;
	});

	$('#sidebar').on('click', '.sb-show', function(){
		$(this).closest('.section').find('.hidden').show('fast');
		$(this).removeClass('sb-show').addClass('sb-hide').html('&ndash;');

		return false;
	});

	$('#sidebar').on('click', '.sb-hide', function(){
		$(this).closest('.section').find('.hidden').hide('fast');
		$(this).removeClass('sb-hide').addClass('sb-show').text('+');

		return false;
	});

	//accordion js
	$('.accordion-head').click(function(){
		toggleAccordion(this);
	});
}); //end ready

function checkportStatus(){
	var portsWidth = 10;

	$('.port').each(function(){
		var index = $(this).index();
		var ph = $('.port-head').eq(index);
		var tallest = 0;

		//if open
		if(ph.find('.port-toggle').is(':checked')){
			$(this).click();
			portsWidth += portOpen;

		//if closed
		}else{
			ph.addClass('closed').find('.port-title, .edit-port').animate({opacity:0}, 0);
			$(this).closest('.port').addClass('closed');

			portsWidth += portClosed;
		}

		if($(this).height() > tallest){
			tallest = $(this).height();
		}
		if($(this).find('.port-edit').length > 1){
			portHeaderEdit += $(this).index();
		}
	});
	//set closed port height to open port height
	$('.port.closed').css('height', $('.port-row').height());
	$('.port-head.closed').css('width',portHeadClosed);
	$('.port.closed').css('width',portClosed);
	portsWidth = portsWidth - portOpen + $(".port-row").width();
	$('#ports, #port-headers').width(portsWidth);
}

function setPortWidth(){
	var port = $('.port');
	var portLength = $('.port').length - 1;
	var portHead = $('.port-head');
	var portContain = $('#port-contain').width() - $(".port-row-head").width() - 20;
	
	var portWidth = (portContain/portLength) - 2;
	var portHeadWidth = (portContain/portLength) - 22;

	portOpen = portWidth;
	portHeadOpen = portOpen - 20;

	if(portOpen < 120){
		port.width(120);
		portHead.width(100);
	}else{
		port.width(portWidth);
		portHead.width(portHeadWidth);
	}
}

function buildURL(){
	url = '';

 	$('.port-toggle:checked').each(function(){
 		var chead = $(this).closest('.port-head');
		var cport = $('.port').eq(chead.index());

 		url = url + (cport.index()+1) + '-';
	});
        url = 'port/settings/'+ url.substring(0,url.length-1)
	$('#editPorts').attr('href', url);
}

function set_port_btns(portNum){
    if ($('#form_port_'+portNum).html() == null ) {
        $('#cancel-btn-'+portNum).hide();
        $('#save-btn-'+portNum).hide();
        $('#edit-btn-'+portNum).show();
    } else {
        $('#cancel-btn-'+portNum).show();
        $('#save-btn-'+portNum).show();
        $('#edit-btn-'+portNum).hide();
    }
}

function set_enetip_port_btns(portNum){
    if ($('#form_enetip_'+portNum).html() == null ) {
        $('#cancel-btn-'+portNum).hide();
        $('#enetip-save-btn-'+portNum).hide();
        $('#edit-btn-'+portNum).show();
    } else {
        $('#cancel-btn-'+portNum).show();
        $('#enetip-save-btn-'+portNum).show();
        $('#edit-btn-'+portNum).hide();
    }
}

function set_mbtcp_port_btns(portNum){
    if ($('#form_mbtcp_'+portNum).html() == null ) {
        $('#cancel-btn-'+portNum).hide();
        $('#mbtcp-save-btn-'+portNum).hide();
        $('#edit-btn-'+portNum).show();
    } else {
        $('#cancel-btn-'+portNum).show();
        $('#mbtcp-save-btn-'+portNum).show();
        $('#edit-btn-'+portNum).hide();
    }
}
function checkLang(lang){
	var langVal = lang.attr('value');
	var selectedLang = $('.' + langVal);
	var clone = selectedLang.clone();
	$('.lang-current').html(clone);
}

function stickyLang(){
	if($(window).width() < 1024){
		$('.lang-list').css('left', $('.lang-selector').offset().left + 2);
	}else{
		$('.lang-list').css('left', 'auto');
	}
}

function closePopup(){
	$('.overlay, .popup').fadeOut('fast');

	return false;
}

function disableEmptyFileInputs(){
	$('input[type=file]').each(function(){
		var length = $(this).val().length;
		if(length > 0){
			$(this).attr('class', 'file-ready');
		}else{
			$(this).attr('class', 'file-empty');
		}
	});

	$('input[type="submit"]').each(function(){
		var prevFile = $(this).prev('input[type="file"]');

		if($(prevFile).hasClass('file-empty')){
			$(this).attr('disabled', true);
		}else{
			$(this).attr('disabled', false);
		}
	});
}